/* ============================================================== */
/*                             C PRELUDE                          */
/* ============================================================== */

%{
#include <stdlib.h>
#include <stdio.h>

extern int	yylex();	/* lexical analyzer generated from lex.l */
extern char	*yytext;	/* last token, defined in lex.l  */

void yyerror(char *s)
  { fprintf(stderr, 
	    "parser: syntax error. Last token was \"%s\"\n",
	    yytext);
    exit(1);
  }
void error(char *s)
  { fprintf(stderr, 
	    "parser: %s\n", s);
    exit(1);
  }
%}


/* ============================================================== */
/*                     TYPES OF NON-TERMINALS                     */         
/* ============================================================== */

%union
{
  int integer;
}


/* ============================================================== */
/*                       TOKENS DECLARATION
/* ============================================================== */

/* dlimiteurs */
%token TK_LPAR TK_RPAR

/* oprations arithmtiques */
%token TK_MUL TK_DIV TK_PLUS TK_MINUS

%token TK_NUM

%type<integer> TK_NUM

/* axiom */
%start expr

%%

/* ============================================================== */
/*                     STANDARD ETF GRAMMAR                       */
/* ============================================================== */

/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/* A COMPLETER                                                    */

e_expr: 
  e_expr TK_PLUS t_expr 
| e_expr TK_MINUS t_expr
| t_expr
;

t_expr: 
  t_expr TK_MUL f_expr
| f_expr
;

f_expr: 
  TK_NUM
| TK_LPAR e_expr TK_RPAR
;

expr: 
  e_expr
;

/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
